#include "globals.h"


/********************************************************************************
 *																				*
 *	     									*
 *																				*
 ********************************************************************************/

LRESULT CALLBACK MainWindowProc (HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam)
{
	switch(message)
	{

	case WM_KEYDOWN: /*   */
		    if (!Active) Active=true;
			
            switch (wParam)
        	{
				case VK_ESCAPE: Active=false;
			}
			break;
	
	case WM_DESTROY: /*   */
		ClearTrash();
		PostQuitMessage (0);
		break;

	case WM_COMMAND:/*    */
            switch(wParam)
			{
			case IDM_INFO:	 // 
			  MessageBox(hWnd,"    ","",64);
			  break;
		
			case IDM_ABOUT:   //  
              DialogBox(
                        hInstance,                   
                        MAKEINTRESOURCE(IDD_ABOUT),   
                        hWnd,                        
                        AboutDlg);
			  break;
           
		    case IDM_EXIT: /*   */
              ClearTrash();
	          PostQuitMessage (0);
	          break;
			}
			break;
	case WM_PAINT:UpdateWnd();
	default:
	//   ,      .
	//     Windows    
	return DefWindowProc (hWnd, message, wParam, lParam);
}
return 0;
}



/********************************************************************************
 *																				*
 *	Main - 																*
 *																				*
 ********************************************************************************/

int WINAPI WinMain(HINSTANCE hInst, HINSTANCE hPrevInst, LPSTR lpszCmdLine, int nCmdShow)
{
	MSG lpMsg;
	WNDCLASSEX wcl;
/*    */

wcl.cbSize = sizeof (wcl);	                     //  WNDCLASSEXA
wcl.style = CS_VREDRAW | CS_HREDRAW;			 //  
wcl.lpfnWndProc = MainWindowProc;	             //  
wcl.cbClsExtra  =0;	                             //   Windows
wcl.cbWndExtra  = 0; 	                         //   Windows
wcl.hInstance = hInst;	                         //  
wcl.hIcon = LoadIcon(hInst, MAKEINTRESOURCE(IDI_APP)); //  
wcl.hCursor = LoadCursorA(NULL,IDC_ARROW);	     // 
//     
wcl.hbrBackground =(HBRUSH) (GetStockObject(BLACK_BRUSH)); 
wcl.lpszMenuName = MAKEINTRESOURCE(IDM_MAIN);	 // 
wcl.lpszClassName = NAME;          	             //  
wcl.hIconSm=NULL;	                             //  ,    

hInstance = hInst;                               //    
                                                 //

//  
if (!RegisterClassEx (&wcl))
return 0;
//       hWnd
hWnd=CreateWindowEx(
	0,		                                     //  
	NAME,       								 //
	TITLE,		                     			 //
	WS_FIXEDWINDOW,         	                 // 
	CW_USEDEFAULT,	                             //X- .   
	CW_USEDEFAULT,                             	 //Y- .   
	640,						                    // 
	480,					                       // 
	NULL,	                                     //  
	NULL,	                                     //  
	hInst,	                                     //.   
	NULL);	                                     //    

// 
SetTimer(hWnd, TIMER_ID,  TIMER_RATE,  (TIMERPROC)TimerProc);

//  
if (!Init())
   {
    MessageBox(hWnd,"   .   ","",16);
    ClearTrash();
	PostQuitMessage (0);
   }

//    
ShowWindow (hWnd, nCmdShow);
UpdateWnd();
/*     */
while (GetMessage(&lpMsg,NULL,0,0))
{
	TranslateMessage(&lpMsg);	//  
	DispatchMessage(&lpMsg);	//  Windows
}
	return lpMsg.wParam;
}	// WinMain



/********************************************************************************
 *																				*
 *	 													*
 *																				*
 ********************************************************************************/

bool Init(void)
{

HBITMAP		hBitmap;		//   
	
	//    . 
	hDC=GetDC(hWnd);
	if (!hDC) return false;

	//      
	hAppleDC=CreateCompatibleDC(hDC);
	if (!hAppleDC) return false;
	
	//    
	hBitmap=LoadBitmap(hInstance, MAKEINTRESOURCE(IDB_APPLE));
	if (!hBitmap) return false;
	
	//        
	SelectObject(hAppleDC, hBitmap);
	
	//     
	DeleteObject(hBitmap);
		
	Active=false; 

	AppleX=0;
	AppleY=0;

	return true;
}



/****************************************************************************
 *																			*
 *	   											*
 *	  ,    					*
 *																			*
 ****************************************************************************/

void CALLBACK TimerProc(HWND hWnd, UINT uMsg, UINT idEvent, DWORD dwTime)
{
	if (idEvent==TIMER_ID && Active)
	{
		if (AppleX<600) AppleX++;
		if (AppleY<400) AppleY++;
	 
	 //  
	 UpdateWnd();

	}
}



/********************************************************************************
 *																				*
 *	 																*
 *																				*
 ********************************************************************************/

void UpdateWnd(void)
{	
	//     
	BitBlt(hDC,			// 
		   AppleX, AppleY,		//  
		   20, 20,		//    
		   hAppleDC,		// 
		   0, 0,		// ,   
		   SRCCOPY);	//  -   
	
	
}



/********************************************************************************
 *																				*
 *	  														*
 *																				*
 ********************************************************************************/

void ClearTrash(void)
{

	ReleaseDC(hWnd, hDC);
	ReleaseDC(hWnd, hAppleDC);
		
}


/********************************************************************************
 *																				*
 *	   " "										*						*
 *																				* 
 ********************************************************************************/

int CALLBACK AboutDlg(HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam) 
{ 
    switch (message) 
    { 
        case WM_COMMAND: 
            if (wParam==IDOK||IDCANCEL) 
				{ 
				EndDialog(hDlg, wParam); 
				return TRUE; 
				} 
    } 
    return FALSE; 
} 







